﻿using System;
using System.Collections.Generic;


namespace Com.Piwigo.Lib.DTO
{

    public class PwgImage
    {
        public Int32 Id { get; set; }
        public Int32 Width { get; set; }
        public Int32 Height { get; set; }
        public String File { get; set; }
        public Uri UrlThunb { get; set; }
        public Uri UrlElement { get; set; }
        public Uri UrlHighDef { get; set; }
        public Int64 Counter { get; set; }
        public DateTime CreatingDate { get; set; }
        public DateTime AvailableDate { get; set; }

        public List<PwgTag> Tags { get; set; }

        public List<PwgCategory> Categories { get; set; }
    }

    //<image 
    //tn_ext="jpg" author="bayral" filesize="62" date_metadata_update="2011-04-12" 
    //has_high="true" high_filesize="1667" level="0" md5sum="198c02a16d5f69c3def90908b33089c3" added_by="1" 
    //<name>P1120275</name>
    //<rates count="0" average=""/>
    //<comment_post author="bayral" key="1312204731.6:2:6f7f43b81bcf86540216c6f39b9122a6"/>
    //<comments page="0" per_page="10" count="1" nb_comments="1">
    //<comment id="1" date="2011-08-01 13:37:59">
    //  <author>bayral</author> 
    //  <content>test[b] demod[/b]</content>
    //</comment>
    //</comments>
    //</image>
    public class PwgImageInfo : PwgImage
    {
        public String ExtThumbail { get; set; }
        public String Author { get; set; }
        public Int64  ImageFileSize { get; set; }
        public DateTime DateupdateMetaData { get; set; }
        public Boolean  hasHighDef { get; set; }
        public Int64 HighDefFileSize { get; set; }
        public Int32 ConfidentialLevel { get; set; }
        public String mdSum { get; set; }
        public Int32 UserIdAddedBy { get; set; }
        public String Name { get; set; }

        public PwgImageRate ImageRate { get; set; }
        public PwgCommentPage ImageComments { get; set; }
        public PwgPostCommentSecurityInfo PostCommenSecurityData { get; set; }
    }

    public class PwgPostCommentSecurityInfo
    {
        public String Author { get; set; }
        public String AllowPostKey { get; set; }
    }

    public class PwgCommentPage : List<PwgComment>
    {
        public Int32 Page { get; set; }
        public Int32 PerPage { get; set; }
        public Int32 CountOf { get; set; }
        public Int32 TotalCommentNumber { get; set; }
    }

    public class PwgComment
    {
        public Int32 Id { get; set; }
        public DateTime CommentDate { get; set; }
        public String Author { get; set; }
        public String Content { get; set; }
    }

    public class PwgImageRate
    {
        public Int32 Count { get; set; }
        public Double Average { get; set; }
        public Double Stdev { get; set; }
    }

    public class PwgImageAdded
    {
        public Int32 Id { get; set; }
        public Uri UrlElement { get; set; }
    }

}
